local t = {}

t['tilemaps'] = {} -- a collection of sprites in a single image
local tilemaps = t['tilemaps']
tilemaps[1] = love.graphics.newImage('Graphics/cubesTilemap.png')
tilemaps[2] = love.graphics.newImage('Graphics/whiteRace.png')

--/////////////////////////////////////

t['cubes'] = {} -- cubes, the basic building block of the world of ooga
local cubes = t['cubes']
cubes[1] = love.graphics.newQuad(2,2,256,256,tilemaps[1]:getDimensions()) -- the frame of a cube, also the template for every other cube
cubes[2] = love.graphics.newQuad(262,2,256,256,tilemaps[1]:getDimensions()) -- see through cube drawn where a block theoretically blocks the player's view
cubes[3] = love.graphics.newQuad(522,2,256,256,tilemaps[1]:getDimensions()) -- the highlighting effect on a cube
cubes[4] = love.graphics.newQuad(782,2,256,256,tilemaps[1]:getDimensions()) -- temperate biome grass

--/////////////////////////////////////

t['dummies'] = {} -- dummies AKA player entities
local dummies = t['dummies']

dummies[1] = {} -- the white race ( of the human species )
local white = dummies[1]
white[1] = love.graphics.newQuad(  2,262,256,256,tilemaps[2]:getDimensions()) -- left
white[2] = love.graphics.newQuad(  2,  2,256,256,tilemaps[2]:getDimensions()) -- top left
white[3] = love.graphics.newQuad(262,  2,256,256,tilemaps[2]:getDimensions()) -- top
white[4] = love.graphics.newQuad(522,  2,256,256,tilemaps[2]:getDimensions()) -- top right
white[5] = love.graphics.newQuad(522,262,256,256,tilemaps[2]:getDimensions()) -- right
white[6] = love.graphics.newQuad(522,522,256,256,tilemaps[2]:getDimensions()) -- bottom right
white[7] = love.graphics.newQuad(262,522,256,256,tilemaps[2]:getDimensions()) -- bottom
white[8] = love.graphics.newQuad(  2,522,256,256,tilemaps[2]:getDimensions()) -- bottom left

--/////////////////////////////////////

t['gui'] = {} -- graphical user interface
local gui = t['gui']
gui[1] = love.graphics.newImage('Graphics/mouse1.png')
gui[2] = love.graphics.newImage('Graphics/mouse2.png')

return t