local t = {}

t.normalToIsoX = function(x,y,o)
  if o == nil then o = 0 end
  local newX = 400 + ((y-x) * (cube_width / 2)) + o
  return newX
end

t.normalToIsoY = function(x,y,z,o)
  if o == nil then o = 0 end
  local newY = 400 + ((x+y) * (cube_depth / 2)) - (cube_depth * (#grid / 2)) - (cube_depth * (z - 1) + o)
  return newY
end

t.new2Dgrid = function(w,h,inv,tbar) -- self explanatory, extra parameter to specify if said grid is an inventory
  if inv == nil then inv = false end
  if tbar == nil then tbar = false end
  local grid = {}
  for x = 1,w do
    grid[x] = {}
    for z = 1,h do
      grid[x][z] = {}
      if inv then
        grid[x][z]['itemID'] = 0
        grid[x][z]['itemN'] = 0
      end
      if tbar then
        grid[x][z][1] = nil
        grid[x][z][2] = nil
      end
    end
  end
  return grid
end

t.new3Dgrid = function(w,l,h,v1,v2,v3,t1,t2,t3) -- if at or above thereshold then apply respective value
  if v1 == nil then v1 = 0 end
  if v2 == nil then v2 = 0 end
  if v3 == nil then v3 = 0 end
  if t1 == nil then t1 = h + 1 end
  if t2 == nil then t1 = h + 1 end
  if t2 == nil then t1 = h + 1 end
  local grid = {}
  for x = 1,w do
		grid[x] = {}
		for y = 1,l do
			grid[x][y] = {}
      for z = 1,h do
        if z >= t1 then grid[x][y][z] = v1 end
        if z >= t2 then grid[x][y][z] = v2 end
        if z >= t3 then grid[x][y][z] = v3 end
        cubes = cubes + 1
      end
		end
	end
  return grid
end

t.cubeIsVisible = function(x,y,z) -- checks if a cube is visible ( in this case covered up by other cubes )
  local screenX, screenY = cam:cameraCoords(gridFuncs.normalToIsoX(x,y),gridFuncs.normalToIsoY(x,y,z,3))
  if not (((screenX < -150) or (screenX > wW + 150)) and ((screenY < -150) or (screenY > wH + 150))) then
    local n = 0
    if gridFuncs.gridCheck(x+1,y,z,0,false) then n = n + 1 end
    if gridFuncs.gridCheck(x,y+1,z,0,false) then n = n + 1 end
    if gridFuncs.gridCheck(x,y,z+1,0,false) then n = n + 1 end
    if n == 3 then return false else return true end
  else return false end
end

t.cubeBlocksPlayerView = function(x,y,z,r) -- this big blob checks if a cube blocks the player's view
  if ((y > player.entity.pos.y) and 
     (z >= player.entity.pos.z) and 
((x <= player.entity.pos.x + r) and 
    (x >= player.entity.pos.x - r))) or
     ((x > player.entity.pos.x) and 
     (z >= player.entity.pos.z) and 
((y <= player.entity.pos.y + r) and 
    (y >= player.entity.pos.y - r))) or
      (z > player.entity.pos.z + 2) then return true else return false end
end

t.gridCheck = function(x,y,z,v,t) -- checks the grid for something, if search is outside the grid then it produces an error
  return pcall(function()
            if t then
              if grid[x][y][z] == v then else print(haha + ahah) end
            elseif not t then
              if grid[x][y][z] ~= v then else print(haha + ahah) end
            end end)
end

t.highestCube = function(x,y,z,c,mz,Mz,a)
  for Z = mz,Mz,1 do
    if a then
      local a, b = pcall( function() if grid[x][y][z+Z] == 0 then grid[x][y][z+Z] = c; return true end end)
      if type(b)=='boolean' then
        if b then break end
      end
    else
      local a, b = pcall( function() if grid[x][y][z+Z] ~= 0 then grid[x][y][z+Z] = c; return true end end)
      if type(b)=='boolean' then
        if b then break end
      end
    end
  end
end

t.lowestCube = function(x,y,z,c,mz,Mz,a)
  for Z = mz,Mz,-1 do
    if a then
      local a, b = pcall( function() if grid[x][y][z+Z] == 0 then grid[x][y][z+Z] = c; return true end end)
      if type(b)=='boolean' then
        if b then break end
      end
    else
      local a, b = pcall( function() if grid[x][y][z+Z] ~= 0 then grid[x][y][z+Z] = c; return true end end)
      if type(b)=='boolean' then
        if b then break end
      end
    end
  end
end

t.gridDraw = function()
  for x = 1,#grid do
		for y = 1,#grid[x] do
			for z = 1,#grid[x][y] do
        if gridFuncs.cubeIsVisible(x,y,z) then
            -- this long if should check if a cube blocks the player view
          if grid[x][y][z] ~= 0 then
            local fade = 1 / (math.abs(player.entity.pos.z - z) * 0.5)
            if gridFuncs.cubeBlocksPlayerView(x,y,z,5) then
              love.graphics.setColor(fade,fade,fade,0.25) -- if so draw a transparent version of the cube
              love.graphics.draw(graphics.tilemaps[1],graphics.cubes[grid[x][y][z]],
              gridFuncs.normalToIsoX(x,y),
              gridFuncs.normalToIsoY(x,y,z,3),
              0,
              1)
              drawCubes = drawCubes + 1
            else -- if not, draw a normal cube
              love.graphics.setColor(fade,fade,fade,1)
              love.graphics.draw(graphics.tilemaps[1],graphics.cubes[grid[x][y][z]],
              gridFuncs.normalToIsoX(x,y),
              gridFuncs.normalToIsoY(x,y,z,3),
              0,
              1)
              drawCubes = drawCubes + 1
            end
          end
            -- drawing the player as if he is part of the grid even though he is not so he can be on the correct layer
          if ((x == player.entity.pos.x) and (y == player.entity.pos.y) and (z == player.entity.pos.z - 1)) then
            love.graphics.setColor(1,1,1,1)
            love.graphics.draw(graphics.tilemaps[2] ,graphics.dummies[1][player.entity.pos.r],
            gridFuncs.normalToIsoX(x,y),
            gridFuncs.normalToIsoY(x,y,z,152),
            0,
            1)
            isoX = gridFuncs.normalToIsoX(x,y,125)
            isoY = gridFuncs.normalToIsoY(x,y,z,152)
          end
        end
      end
    end
  end
end

return t